/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.DefaultSchema;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Indexes;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.Keys;
import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records.InvoiceRecord;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.Arrays;
import java.util.List;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Invoice extends TableImpl<InvoiceRecord> {

    private static final long serialVersionUID = -389144063;

    /**
     * The reference instance of <code>INVOICE</code>
     */
    public static final Invoice INVOICE = new Invoice();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<InvoiceRecord> getRecordType() {
        return InvoiceRecord.class;
    }

    /**
     * The column <code>INVOICE.ID_INVOICE</code>.
     */
    public final TableField<InvoiceRecord, Integer> ID_INVOICE = createField("ID_INVOICE", org.jooq.impl.SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>INVOICE.INVOICE_CODE</code>.
     */
    public final TableField<InvoiceRecord, String> INVOICE_CODE = createField("INVOICE_CODE", org.jooq.impl.SQLDataType.VARCHAR(100), this, "");

    /**
     * The column <code>INVOICE.CLIENT_ID</code>.
     */
    public final TableField<InvoiceRecord, Integer> CLIENT_ID = createField("CLIENT_ID", org.jooq.impl.SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>INVOICE.CREATION_DATE</code>.
     */
    public final TableField<InvoiceRecord, Timestamp> CREATION_DATE = createField("CREATION_DATE", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false), this, "");

    /**
     * The column <code>INVOICE.LAST_UPDATE_DATE</code>.
     */
    public final TableField<InvoiceRecord, Timestamp> LAST_UPDATE_DATE = createField("LAST_UPDATE_DATE", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false), this, "");

    /**
     * The column <code>INVOICE.USER_ID</code>.
     */
    public final TableField<InvoiceRecord, String> USER_ID = createField("USER_ID", org.jooq.impl.SQLDataType.VARCHAR(45), this, "");

    /**
     * The column <code>INVOICE.TOTAL_INVOICE</code>.
     */
    public final TableField<InvoiceRecord, BigDecimal> TOTAL_INVOICE = createField("TOTAL_INVOICE", org.jooq.impl.SQLDataType.DECIMAL(34, 20).nullable(false), this, "");

    /**
     * The column <code>INVOICE.VAT</code>.
     */
    public final TableField<InvoiceRecord, Double> VAT = createField("VAT", org.jooq.impl.SQLDataType.FLOAT, this, "");

    /**
     * The column <code>INVOICE.NOTE</code>.
     */
    public final TableField<InvoiceRecord, String> NOTE = createField("NOTE", org.jooq.impl.SQLDataType.VARCHAR(1000), this, "");

    /**
     * The column <code>INVOICE.STATUS</code>.
     */
    public final TableField<InvoiceRecord, String> STATUS = createField("STATUS", org.jooq.impl.SQLDataType.VARCHAR(45).nullable(false), this, "");

    /**
     * The column <code>INVOICE.PDF_PATH</code>.
     */
    public final TableField<InvoiceRecord, String> PDF_PATH = createField("PDF_PATH", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>INVOICE.PDF</code>.
     */
    public final TableField<InvoiceRecord, byte[]> PDF = createField("PDF", org.jooq.impl.SQLDataType.BLOB, this, "");

    /**
     * The column <code>INVOICE.REQUEST_ID</code>.
     */
    public final TableField<InvoiceRecord, String> REQUEST_ID = createField("REQUEST_ID", org.jooq.impl.SQLDataType.VARCHAR(255), this, "");

    /**
     * The column <code>INVOICE.DATE_OF_PERTINENCE</code>.
     */
    public final TableField<InvoiceRecord, Timestamp> DATE_OF_PERTINENCE = createField("DATE_OF_PERTINENCE", org.jooq.impl.SQLDataType.TIMESTAMP.nullable(false), this, "");

    /**
     * The column <code>INVOICE.INVOICE_TYPE</code>. valori ammissibili: AUTOMATICA , ANTICIPO
     */
    public final TableField<InvoiceRecord, String> INVOICE_TYPE = createField("INVOICE_TYPE", org.jooq.impl.SQLDataType.VARCHAR(45).nullable(false).defaultValue(org.jooq.impl.DSL.inline("AUTOMATICA", org.jooq.impl.SQLDataType.VARCHAR)), this, "valori ammissibili: AUTOMATICA , ANTICIPO");

    /**
     * Create a <code>INVOICE</code> table reference
     */
    public Invoice() {
        this(DSL.name("INVOICE"), null);
    }

    /**
     * Create an aliased <code>INVOICE</code> table reference
     */
    public Invoice(String alias) {
        this(DSL.name(alias), INVOICE);
    }

    /**
     * Create an aliased <code>INVOICE</code> table reference
     */
    public Invoice(Name alias) {
        this(alias, INVOICE);
    }

    private Invoice(Name alias, Table<InvoiceRecord> aliased) {
        this(alias, aliased, null);
    }

    private Invoice(Name alias, Table<InvoiceRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""));
    }

    public <O extends Record> Invoice(Table<O> child, ForeignKey<O, InvoiceRecord> key) {
        super(child, key, INVOICE);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Schema getSchema() {
        return DefaultSchema.DEFAULT_SCHEMA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<Index> getIndexes() {
        return Arrays.<Index>asList(Indexes.INVOICE_FK_CLIENT_ID_INVOICE_IDX, Indexes.INVOICE_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Identity<InvoiceRecord, Integer> getIdentity() {
        return Keys.IDENTITY_INVOICE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public UniqueKey<InvoiceRecord> getPrimaryKey() {
        return Keys.KEY_INVOICE_PRIMARY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<UniqueKey<InvoiceRecord>> getKeys() {
        return Arrays.<UniqueKey<InvoiceRecord>>asList(Keys.KEY_INVOICE_PRIMARY);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public List<ForeignKey<InvoiceRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<InvoiceRecord, ?>>asList(Keys.FK_CLIENT_ID_INVOICE);
    }

    public AnagClient anagClient() {
        return new AnagClient(this, Keys.FK_CLIENT_ID_INVOICE);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Invoice as(String alias) {
        return new Invoice(DSL.name(alias), this);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Invoice as(Name alias) {
        return new Invoice(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public Invoice rename(String name) {
        return new Invoice(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public Invoice rename(Name name) {
        return new Invoice(name, null);
    }
}
